public class Bug2
{
  public static void main(String[] args) 
    throws java.net.MalformedURLException, ClassNotFoundException
  {
    String url = "file://" + args[0];
    ClassLoader loader = new java.net.URLClassLoader
      (new java.net.URL[]{ new java.net.URL(url) })
      {
	protected Class loadClass(String name, boolean resolve)
	  throws ClassNotFoundException
	{
	  /* Change the default behviour, which is to look up the 
	     parent classloader first. Instead, look it up after this one,
	     so that the inlined methods are found here, but the
	     interfaces they implement are found in the system classloader,
	     so that the casts for using them succeed.
	  */
	  Class res = findLoadedClass(name);

	  if (res == null)
	    try {
	      res = this.findClass(name);
	    } 
	    catch (ClassNotFoundException ex) {}

	  if (res == null)
	    res = getParent().loadClass(name);

	  if (resolve && res != null)
	    resolveClass(res);

	  return res;
	}
      };
    loader.loadClass(args[1]);
  }
}
